diff --git a/compiler/coreSyn/CoreArity.lhs b/compiler/coreSyn/CoreArity.lhs
index 62f9b7e..e31c361 100644
--- a/compiler/coreSyn/CoreArity.lhs
+++ b/compiler/coreSyn/CoreArity.lhs
@@ -3,20 +3,14 @@
 % (c) The GRASP/AQUA Project, Glasgow University, 1992-1998
 %
 
-	Arity and ete expansion
+        Arity and ete expansion
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 -- | Arit and eta expansion
 module CoreArity (
-	manifestArity, exprArity, exprBotStrictness_maybe,
-	exprEtaExpandArity, CheapFun, etaExpand
+        manifestArity, exprArity, exprBotStrictness_maybe,
+        exprEtaExpandArity, CheapFun, etaExpand
     ) where
 
 #include "HsVersions.h"
@@ -30,7 +24,7 @@ import Var
 import VarEnv
 import Id
 import Type
-import TyCon	( initRecTc, checkRecTc )
+import TyCon    ( initRecTc, checkRecTc )
 import Coercion
 import BasicTypes
 import Unique
@@ -41,9 +35,9 @@ import Pair
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
               manifestArity and exprArity
-%*									*
+%*                                                                      *
 %************************************************************************
 
 exprArity is a cheap-and-cheerful version of exprEtaExpandArity.
@@ -56,46 +50,46 @@ compute the ArityInfo for the Id.
 Originally I thought that it was enough just to look for top-level lambdas, but
 it isn't.  I've seen this
 
-	foo = PrelBase.timesInt
+        foo = PrelBase.timesInt
 
 We want foo to get arity 2 even though the eta-expander will leave it
 unchanged, in the expectation that it'll be inlined.  But occasionally it
 isn't, because foo is blacklisted (used in a rule).  
 
 Similarly, see the ok_note check in exprEtaExpandArity.  So 
-	f = __inline_me (\x -> e)
+        f = __inline_me (\x -> e)
 won't be eta-expanded.
 
 And in any case it seems more robust to have exprArity be a bit more intelligent.
-But note that 	(\x y z -> f x y z)
+But note that   (\x y z -> f x y z)
 should have arity 3, regardless of f's arity.
 
 \begin{code}
 manifestArity :: CoreExpr -> Arity
 -- ^ manifestArity sees how many leading value lambdas there are
-manifestArity (Lam v e) | isId v    	= 1 + manifestArity e
-			| otherwise 	= manifestArity e
+manifestArity (Lam v e) | isId v        = 1 + manifestArity e
+                        | otherwise     = manifestArity e
 manifestArity (Tick t e) | not (tickishIsCode t) =  manifestArity e
-manifestArity (Cast e _)            	= manifestArity e
-manifestArity _                     	= 0
+manifestArity (Cast e _)                = manifestArity e
+manifestArity _                         = 0
 
 ---------------
 exprArity :: CoreExpr -> Arity
 -- ^ An approximate, fast, version of 'exprEtaExpandArity'
 exprArity e = go e
   where
-    go (Var v) 	       	           = idArity v
-    go (Lam x e) | isId x    	   = go e + 1
-    		 | otherwise 	   = go e
+    go (Var v)                     = idArity v
+    go (Lam x e) | isId x          = go e + 1
+                 | otherwise       = go e
     go (Tick t e) | not (tickishIsCode t) = go e
     go (Cast e co)                 = trim_arity (go e) (pSnd (coercionKind co))
                                         -- Note [exprArity invariant]
     go (App e (Type _))            = go e
     go (App f a) | exprIsTrivial a = (go f - 1) `max` 0
         -- See Note [exprArity for applications]
-	-- NB: coercions count as a value argument
+        -- NB: coercions count as a value argument
 
-    go _		       	   = 0
+    go _                           = 0
 
     trim_arity :: Arity -> Type -> Arity
     trim_arity arity ty = arity `min` length (typeArity ty)
@@ -119,13 +113,13 @@ typeArity ty
       , Just (ty', _) <- instNewTyCon_maybe tc tys
       , Just rec_nts' <- checkRecTc rec_nts tc  -- See Note [Expanding newtypes]
                                                 -- in TyCon
---   , not (isClassTyCon tc)	-- Do not eta-expand through newtype classes
---    		      		-- See Note [Newtype classes and eta expansion]
+--   , not (isClassTyCon tc)    -- Do not eta-expand through newtype classes
+--                              -- See Note [Newtype classes and eta expansion]
 --                              (no longer required)
       = go rec_nts' ty'
-  	-- Important to look through non-recursive newtypes, so that, eg 
-  	--	(f x)   where f has arity 2, f :: Int -> IO ()
-  	-- Here we want to get arity 1 for the result!
+        -- Important to look through non-recursive newtypes, so that, eg 
+        --      (f x)   where f has arity 2, f :: Int -> IO ()
+        -- Here we want to get arity 1 for the result!
         --
         -- AND through a layer of recursive newtypes
         -- e.g. newtype Stream m a b = Stream (m (Either b (a, Stream m a b)))
@@ -140,8 +134,8 @@ exprBotStrictness_maybe :: CoreExpr -> Maybe (Arity, StrictSig)
 -- float-out
 exprBotStrictness_maybe e
   = case getBotArity (arityType env e) of
-	Nothing -> Nothing
-	Just ar -> Just (ar, sig ar)
+        Nothing -> Nothing
+        Just ar -> Just (ar, sig ar)
   where
     env    = AE { ae_bndrs = [], ae_ped_bot = True, ae_cheap_fn = \ _ _ -> False }
     sig ar = mkStrictSig (mkTopDmdType (replicate ar topDmd) botRes)
@@ -243,9 +237,9 @@ When we come to an application we check that the arg is trivial.
 
 
 %************************************************************************
-%*									*
-	   Computing the "arity" of an expression
-%*									*
+%*                                                                      *
+           Computing the "arity" of an expression
+%*                                                                      *
 %************************************************************************
 
 Note [Definition of arity]
@@ -273,7 +267,7 @@ It's all a bit more subtle than it looks:
 Note [One-shot lambdas]
 ~~~~~~~~~~~~~~~~~~~~~~~
 Consider one-shot lambdas
-		let x = expensive in \y z -> E
+                let x = expensive in \y z -> E
 We want this to have arity 1 if the \y-abstraction is a 1-shot lambda.
 
 Note [Dealing with bottom]
@@ -289,7 +283,7 @@ In this case we do eta-expand, in order to get that \s to the
 top, and give f arity 2.
 
 This isn't really right in the presence of seq.  Consider
-	(f bot) `seq` 1
+        (f bot) `seq` 1
 
 This should diverge!  But if we eta-expand, it won't.  We ignore this
 "problem" (unless -fpedantic-bottoms is on), because being scrupulous
@@ -297,13 +291,13 @@ would lose an important transformation for many programs. (See
 Trac #5587 for an example.)
 
 Consider also
-	f = \x -> error "foo"
+        f = \x -> error "foo"
 Here, arity 1 is fine.  But if it is
-	f = \x -> case x of 
-			True  -> error "foo"
-			False -> \y -> x+y
+        f = \x -> case x of 
+                        True  -> error "foo"
+                        False -> \y -> x+y
 then we want to get arity 2.  Technically, this isn't quite right, because
-	(f True) `seq` 1
+        (f True) `seq` 1
 should diverge, but it'll converge if we eta-expand f.  Nevertheless, we
 do so; it improves some programs significantly, and increasing convergence
 isn't a bad thing.  Hence the ABot/ATop in ArityType.
@@ -339,34 +333,34 @@ Of course both (1) and (2) are readily defeated by disguising the bottoms.
 Non-recursive newtypes are transparent, and should not get in the way.
 We do (currently) eta-expand recursive newtypes too.  So if we have, say
 
-	newtype T = MkT ([T] -> Int)
+        newtype T = MkT ([T] -> Int)
 
 Suppose we have
-	e = coerce T f
+        e = coerce T f
 where f has arity 1.  Then: etaExpandArity e = 1; 
 that is, etaExpandArity looks through the coerce.
 
 When we eta-expand e to arity 1: eta_expand 1 e T
-we want to get: 		 coerce T (\x::[T] -> (coerce ([T]->Int) e) x)
+we want to get:                  coerce T (\x::[T] -> (coerce ([T]->Int) e) x)
 
   HOWEVER, note that if you use coerce bogusly you can ge
-  	coerce Int negate
+        coerce Int negate
   And since negate has arity 2, you might try to eta expand.  But you can't
   decopose Int to a function type.   Hence the final case in eta_expand.
   
 Note [The state-transformer hack]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Suppose we have 
-	f = e
+        f = e
 where e has arity n.  Then, if we know from the context that f has
 a usage type like
-	t1 -> ... -> tn -1-> t(n+1) -1-> ... -1-> tm -> ...
+        t1 -> ... -> tn -1-> t(n+1) -1-> ... -1-> tm -> ...
 then we can expand the arity to m.  This usage type says that
 any application (x e1 .. en) will be applied to uniquely to (m-n) more args
 Consider f = \x. let y = <expensive> 
-		 in case x of
-		      True  -> foo
-		      False -> \(s:RealWorld) -> e
+                 in case x of
+                      True  -> foo
+                      False -> \(s:RealWorld) -> e
 where foo has arity 1.  Then we want the state hack to
 apply to foo too, so we can eta expand the case.
 
@@ -469,8 +463,8 @@ Example:
 
 Suppose f = \xy. x+y
 Then  f             :: AT [False,False] ATop
-      f v           :: AT [False] 	ATop
-      f <expensive> :: AT [] 	        ATop
+      f v           :: AT [False]       ATop
+      f <expensive> :: AT []            ATop
 
 -------------------- Main arity code ----------------------------
 \begin{code}
@@ -481,22 +475,22 @@ data ArityType = ATop [OneShot] | ABot Arity
 
 type OneShot = Bool    -- False <=> Know nothing
                        -- True  <=> Can definitely float inside this lambda
-	               -- The 'True' case can arise either because a binder
-		       -- is marked one-shot, or because it's a state lambda
-		       -- and we have the state hack on
+                       -- The 'True' case can arise either because a binder
+                       -- is marked one-shot, or because it's a state lambda
+                       -- and we have the state hack on
 
 vanillaArityType :: ArityType
-vanillaArityType = ATop []	-- Totally uninformative
+vanillaArityType = ATop []      -- Totally uninformative
 
 -- ^ The Arity returned is the number of value args the
 -- expression can be applied to without doing much work
 exprEtaExpandArity :: DynFlags -> CheapAppFun -> CoreExpr -> Arity
 -- exprEtaExpandArity is used when eta expanding
--- 	e  ==>  \xy -> e x y
+--      e  ==>  \xy -> e x y
 exprEtaExpandArity dflags cheap_app e
   = case (arityType env e) of
       ATop (os:oss) 
-        | os || has_lam e -> 1 + length oss	-- Note [Eta expanding thunks]
+        | os || has_lam e -> 1 + length oss     -- Note [Eta expanding thunks]
         | otherwise       -> 0
       ATop []             -> 0
       ABot n              -> n
@@ -532,9 +526,9 @@ dictionary bindings.  This improves arities. Thereby, it also
 means that full laziness is less prone to floating out the
 application of a function to its dictionary arguments, which
 can thereby lose opportunities for fusion.  Example:
-	foo :: Ord a => a -> ...
+        foo :: Ord a => a -> ...
      foo = /\a \(d:Ord a). let d' = ...d... in \(x:a). ....
-     	-- So foo has arity 1
+        -- So foo has arity 1
 
      f = \x. foo dInt $ bar x
 
@@ -555,7 +549,7 @@ should we eta-expand it? Well, if 'x' is a one-shot state token
 then 'yes' because 'f' will only be applied once.  But otherwise
 we (conservatively) say no.  My main reason is to avoid expanding
 PAPSs
-	f = g d  ==>  f = \x. g d x
+        f = g d  ==>  f = \x. g d x
 because that might in turn make g inline (if it has an inline pragma), 
 which we might not want.  After all, INLINE pragmas say "inline only
 when saturated" so we don't want to be too gung-ho about saturating!
@@ -587,7 +581,7 @@ andArityType (ABot n1) (ABot n2)
 andArityType (ATop as)  (ABot _)  = ATop as
 andArityType (ABot _)   (ATop bs) = ATop bs
 andArityType (ATop as)  (ATop bs) = ATop (as `combine` bs)
-  where	     -- See Note [Combining case branches]
+  where      -- See Note [Combining case branches]
     combine (a:as) (b:bs) = (a && b) : combine as bs
     combine []     bs     = take_one_shots bs
     combine as     []     = take_one_shots as
@@ -617,9 +611,9 @@ lambda wasn't one-shot we don't want to do this.
 \begin{code}
 ---------------------------
 type CheapFun = CoreExpr -> Maybe Type -> Bool
-     	-- How to decide if an expression is cheap
-	-- If the Maybe is Just, the type is the type
-	-- of the expression; Nothing means "don't know"
+        -- How to decide if an expression is cheap
+        -- If the Maybe is Just, the type is the type
+        -- of the expression; Nothing means "don't know"
 
 data ArityEnv 
   = AE { ae_bndrs :: [Id]          -- Enclosing value-lambda Ids
@@ -653,17 +647,17 @@ arityType _ (Var v)
   | otherwise
   = ATop (take (idArity v) one_shots)
   where
-    one_shots :: [Bool]	    -- One-shot-ness derived from the type
+    one_shots :: [Bool]     -- One-shot-ness derived from the type
     one_shots = typeArity (idType v)
 
-	-- Lambdas; increase arity
+        -- Lambdas; increase arity
 arityType env (Lam x e)
   | isId x    = arityLam x (arityType env' e)
   | otherwise = arityType env e
   where
     env' = env { ae_bndrs = x : ae_bndrs env }
 
-	-- Applications; decrease arity, except for types
+        -- Applications; decrease arity, except for types
 arityType env (App fun (Type _))
    = arityType env fun
 arityType env (App fun arg )
@@ -672,14 +666,14 @@ arityType env (App fun arg )
      env' = env { ae_bndrs = case ae_bndrs env of
                                 { [] -> []; (_:xs) -> xs } }
 
-	-- Case/Let; keep arity if either the expression is cheap
-	-- or it's a 1-shot lambda
-	-- The former is not really right for Haskell
-	--	f x = case x of { (a,b) -> \y. e }
-	--  ===>
-	--	f x y = case x of { (a,b) -> e }
-	-- The difference is observable using 'seq'
-	--
+        -- Case/Let; keep arity if either the expression is cheap
+        -- or it's a 1-shot lambda
+        -- The former is not really right for Haskell
+        --      f x = case x of { (a,b) -> \y. e }
+        --  ===>
+        --      f x y = case x of { (a,b) -> e }
+        -- The difference is observable using 'seq'
+        --
 arityType env (Case scrut _ _ alts)
   | exprIsBottom scrut || null alts
   = ABot 0     -- Do not eta expand
@@ -687,13 +681,13 @@ arityType env (Case scrut _ _ alts)
   | otherwise
   = case alts_type of
      ABot n  | n>0       -> ATop []    -- Don't eta expand 
-     	     | otherwise -> ABot 0     -- if RHS is bottomming
-    			               -- See Note [Dealing with bottom (2)]
+             | otherwise -> ABot 0     -- if RHS is bottomming
+                                       -- See Note [Dealing with bottom (2)]
 
      ATop as | not (ae_ped_bot env)    -- Check -fpedantic-bottoms
              , is_under scrut             -> ATop as
              | exprOkForSpeculation scrut -> ATop as
-             | otherwise                  -> ATop (takeWhile id as)	    
+             | otherwise                  -> ATop (takeWhile id as)         
   where
     -- is_under implements Note [Dealing with bottom (3)]
     is_under (Var f)           = f `elem` ae_bndrs env
@@ -718,29 +712,29 @@ arityType _ _ = vanillaArityType
   
   
 %************************************************************************
-%*									*
-              The main eta-expander								
-%*									*
+%*                                                                      *
+              The main eta-expander                                                             
+%*                                                                      *
 %************************************************************************
 
 We go for:
    f = \x1..xn -> N  ==>   f = \x1..xn y1..ym -> N y1..ym
-				 (n >= 0)
+                                 (n >= 0)
 
 where (in both cases) 
 
-	* The xi can include type variables
+        * The xi can include type variables
 
-	* The yi are all value variables
+        * The yi are all value variables
 
-	* N is a NORMAL FORM (i.e. no redexes anywhere)
-	  wanting a suitable number of extra args.
+        * N is a NORMAL FORM (i.e. no redexes anywhere)
+          wanting a suitable number of extra args.
 
 The biggest reason for doing this is for cases like
 
-	f = \x -> case x of
-		    True  -> \y -> e1
-		    False -> \y -> e2
+        f = \x -> case x of
+                    True  -> \y -> e1
+                    False -> \y -> e2
 
 Here we want to get the lambdas together.  A good example is the nofib
 program fibheaps, which gets 25% more allocation if you don't do this
@@ -766,8 +760,8 @@ means you can't really use it in CorePrep, which is painful.
 Note [Eta expansion and SCCs]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Note that SCCs are not treated specially by etaExpand.  If we have
-	etaExpand 2 (\x -> scc "foo" e)
-	= (\xy -> (scc "foo" e) y)
+        etaExpand 2 (\x -> scc "foo" e)
+        = (\xy -> (scc "foo" e) y)
 So the costs of evaluating 'e' (not 'e y') are attributed to "foo"
 
 \begin{code}
@@ -781,14 +775,14 @@ So the costs of evaluating 'e' (not 'e y') are attributed to "foo"
 -- We should have that:
 --
 -- > ty = exprType e = exprType e'
-etaExpand :: Arity	  	-- ^ Result should have this number of value args
-	  -> CoreExpr	        -- ^ Expression to expand
-	  -> CoreExpr
+etaExpand :: Arity              -- ^ Result should have this number of value args
+          -> CoreExpr           -- ^ Expression to expand
+          -> CoreExpr
 -- etaExpand deals with for-alls. For example:
---		etaExpand 1 E
+--              etaExpand 1 E
 -- where  E :: forall a. a -> a
 -- would return
---	(/\b. \y::a -> E b y)
+--      (/\b. \y::a -> E b y)
 --
 -- It deals with coerces too, though they are now rare
 -- so perhaps the extra code isn't worth it
@@ -800,20 +794,20 @@ etaExpand n orig_expr
       -- Note [Eta expansion and SCCs]
     go 0 expr = expr
     go n (Lam v body) | isTyVar v = Lam v (go n     body)
-       	              | otherwise = Lam v (go (n-1) body)
+                      | otherwise = Lam v (go (n-1) body)
     go n (Cast expr co) = Cast (go n expr) co
     go n expr           = -- pprTrace "ee" (vcat [ppr orig_expr, ppr expr, ppr etas]) $
-       	 		  etaInfoAbs etas (etaInfoApp subst' expr etas)
-    	  		where
-			    in_scope = mkInScopeSet (exprFreeVars expr)
-			    (in_scope', etas) = mkEtaWW n orig_expr in_scope (exprType expr)
-			    subst' = mkEmptySubst in_scope'
+                          etaInfoAbs etas (etaInfoApp subst' expr etas)
+                        where
+                            in_scope = mkInScopeSet (exprFreeVars expr)
+                            (in_scope', etas) = mkEtaWW n orig_expr in_scope (exprType expr)
+                            subst' = mkEmptySubst in_scope'
 
-      	      	       	        -- Wrapper    Unwrapper
+                                -- Wrapper    Unwrapper
 --------------
-data EtaInfo = EtaVar Var	-- /\a. [],   [] a
-     	                 	-- \x.  [],   [] x
-	     | EtaCo Coercion   -- [] |> co,  [] |> (sym co)
+data EtaInfo = EtaVar Var       -- /\a. [],   [] a
+                                -- \x.  [],   [] x
+             | EtaCo Coercion   -- [] |> co,  [] |> (sym co)
 
 instance Outputable EtaInfo where
    ppr (EtaVar v) = ptext (sLit "EtaVar") <+> ppr v
@@ -822,7 +816,7 @@ instance Outputable EtaInfo where
 pushCoercion :: Coercion -> [EtaInfo] -> [EtaInfo]
 pushCoercion co1 (EtaCo co2 : eis)
   | isReflCo co = eis
-  | otherwise	= EtaCo co : eis
+  | otherwise   = EtaCo co : eis
   where
     co = co1 `mkTransCo` co2
 
@@ -837,7 +831,7 @@ etaInfoAbs (EtaCo co : eis) expr = Cast (etaInfoAbs eis expr) (mkSymCo co)
 --------------
 etaInfoApp :: Subst -> CoreExpr -> [EtaInfo] -> CoreExpr
 -- (etaInfoApp s e eis) returns something equivalent to 
--- 	       ((substExpr s e) `appliedto` eis)
+--             ((substExpr s e) `appliedto` eis)
 
 etaInfoApp subst (Lam v1 e) (EtaVar v2 : eis) 
   = etaInfoApp (CoreSubst.extendSubstWithVar subst v1 v2) e eis
@@ -853,8 +847,8 @@ etaInfoApp subst (Case e b ty alts) eis
     (subst1, b1) = substBndr subst b
     alts' = map subst_alt alts
     subst_alt (con, bs, rhs) = (con, bs', etaInfoApp subst2 rhs eis) 
-    	      where
-	      	 (subst2,bs') = substBndrs subst1 bs
+              where
+                 (subst2,bs') = substBndrs subst1 bs
 
     mk_alts_ty ty []               = ty
     mk_alts_ty ty (EtaVar v : eis) = mk_alts_ty (applyTypeToArg ty (varToCoreExpr v)) eis
@@ -877,18 +871,18 @@ etaInfoApp subst e eis
 
 --------------
 mkEtaWW :: Arity -> CoreExpr -> InScopeSet -> Type
-	-> (InScopeSet, [EtaInfo])
-	-- EtaInfo contains fresh variables,
-	--   not free in the incoming CoreExpr
-	-- Outgoing InScopeSet includes the EtaInfo vars
-	--   and the original free vars
+        -> (InScopeSet, [EtaInfo])
+        -- EtaInfo contains fresh variables,
+        --   not free in the incoming CoreExpr
+        -- Outgoing InScopeSet includes the EtaInfo vars
+        --   and the original free vars
 
 mkEtaWW orig_n orig_expr in_scope orig_ty
   = go orig_n empty_subst orig_ty []
   where
     empty_subst = TvSubst in_scope emptyTvSubstEnv
 
-    go n subst ty eis	    -- See Note [exprArity invariant]
+    go n subst ty eis       -- See Note [exprArity invariant]
        | n == 0
        = (getTvInScope subst, reverse eis)
 
@@ -901,25 +895,25 @@ mkEtaWW orig_n orig_expr in_scope orig_ty
        , let (subst', eta_id') = freshEtaId n subst arg_ty 
            -- Avoid free vars of the original expression
        = go (n-1) subst' res_ty (EtaVar eta_id' : eis)
-       				   
+                                   
        | Just(ty',co) <- splitNewTypeRepCo_maybe ty
-       = 	-- Given this:
-       		-- 	newtype T = MkT ([T] -> Int)
-       		-- Consider eta-expanding this
-       		--  	eta_expand 1 e T
-       		-- We want to get
-       		--	coerce T (\x::[T] -> (coerce ([T]->Int) e) x)
+       =        -- Given this:
+                --      newtype T = MkT ([T] -> Int)
+                -- Consider eta-expanding this
+                --      eta_expand 1 e T
+                -- We want to get
+                --      coerce T (\x::[T] -> (coerce ([T]->Int) e) x)
          go n subst ty' (EtaCo co : eis)
 
-       | otherwise	 -- We have an expression of arity > 0, 
-       	 		 -- but its type isn't a function. 		   
+       | otherwise       -- We have an expression of arity > 0, 
+                         -- but its type isn't a function.                 
        = WARN( True, (ppr orig_n <+> ppr orig_ty) $$ ppr orig_expr )
          (getTvInScope subst, reverse eis)
-    	-- This *can* legitmately happen:
-    	-- e.g.  coerce Int (\x. x) Essentially the programmer is
-	-- playing fast and loose with types (Happy does this a lot).
-	-- So we simply decline to eta-expand.  Otherwise we'd end up
-	-- with an explicit lambda having a non-function type
+        -- This *can* legitmately happen:
+        -- e.g.  coerce Int (\x. x) Essentially the programmer is
+        -- playing fast and loose with types (Happy does this a lot).
+        -- So we simply decline to eta-expand.  Otherwise we'd end up
+        -- with an explicit lambda having a non-function type
    
 
 --------------
@@ -945,8 +939,8 @@ freshEtaId n subst ty
       = (subst', eta_id')
       where
         ty'     = Type.substTy subst ty
-	eta_id' = uniqAway (getTvInScope subst) $
-		  mkSysLocal (fsLit "eta") (mkBuiltinUnique n) ty'
-	subst'  = extendTvInScope subst eta_id'		  
+        eta_id' = uniqAway (getTvInScope subst) $
+                  mkSysLocal (fsLit "eta") (mkBuiltinUnique n) ty'
+        subst'  = extendTvInScope subst eta_id'           
 \end{code}
 
